///////////////////////////////////////////////////////////////////////////////////////////
//Autor: Thomas Ningelgen  thomas@ningelgen.eu
/////////////////////////////////////////////////////////////////////////////////////////////
//Schwarm-Simulation: Drei Regeln für jedes Individum bezogen auf das Verhalten der Nachbarn
//System bestehend aus Schwarm, Räuber und Hindernissen
///////////////////////////////////////////////////////////////////////////////////////////////
ArrayList<SchwarmElement> schwarm = new ArrayList<SchwarmElement>(); //Speicher für Schwarm-Elemente 
ArrayList<SchwarmElement> schwarmElementZuLoeschen = new ArrayList<SchwarmElement>(); //da kommen die gefressenen rein.
ArrayList<SchwarmElement> schwarmElementNeuGeboren = new ArrayList<SchwarmElement>(); //...und da die Neugeborenen...
ArrayList<Raeuber> raeuber = new ArrayList<Raeuber>(); //Speicher für Raeuber
ArrayList<Hindernis> hindernisse = new ArrayList<Hindernis>();//Speicher für Hindernisse
FutterStelle futter;
float dFutter; //Abstand zur Futterstelle
int schwarmGroesse = 150; //Anzahl der zu Beginn initialisierten Schwarm-Elemente (max 500)
int aktuelleSchwarmGroesse = 150;
int anzahlRaeuber = 2; //Anzahl der zu Beginn initialisierten Raeuber
float abstandRand = 40;
boolean schwarmVerhalten = true; //umschalten Schwarm-Verhalten.
boolean voegelAnzeigen = false; //umschalten Vögel anzeigen
boolean eingeschlossen = true;
boolean jagenR = true; //umschalten jagen/nicht jagen
boolean raeuberGeboren = false;
boolean raeuberGestorben = false;

PrintWriter daten;

void setup() {
  size(700, 700);
  smooth();
  colorMode(HSB,256,100,100);
  background(180, 100, 100);
  for (int i=0; i<schwarmGroesse; i++) { //Schwarm erzeugen 
    schwarm.add(new SchwarmElement(new PVector(random(0, width), random(0, height))));
  }
  for (int j=0; j<anzahlRaeuber; j++) { //Räuber erzeugen
    raeuber.add(new Raeuber(new PVector(random(0, width), random(0, height))));
  }
  futter = new FutterStelle(new PVector(width/2,height/2), 40, color(90,90,100,220));

}
/////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void draw() {

  background(180, 100, 100);//blauer Hintergrund
  fill(0, 0, 100);//Schrift weiß
  textSize(28);
  //Anzeige der aktuellen Anzahl von Räubern und Beute
  text(schwarm.size()+"     "+raeuber.size(), width/2-20, 50);
   
///////////////////////////////////////////////////////////////////////////
  for(Hindernis hindernis: hindernisse){
     hindernis.display();//Hindernisse anzeigen    
  }
  futter.display();//Futterstelle anzeigen
///////////////////////////////////////////////////////////////////////////////
  for (SchwarmElement schwarmElement: schwarm)  {  //Über den ganzen Schwarm ausführen
    if (jagenR) { //Fliehe vor Räubern
      for (Raeuber einRaeuber: raeuber) { 
        PVector raeuberOrt = einRaeuber.getOrt();
        schwarmElement.fluchtKraft(raeuberOrt); //schwarmElemente sind nie Räuber
      }
    }
    for (Hindernis hindernis: hindernisse) { //Hindernis umgehen     
      schwarmElement.hindernisAbstKraft(hindernis.ort, hindernis.radius);
    }
    if (schwarmVerhalten) { //Schwarm-Regeln ausführen
       schwarmElement.schwarmRegelnAnwenden(schwarm);
    }
    if (eingeschlossen){//Wände undurchlässig
      schwarmElement.eingeschlossen = true;
    }else{
           schwarmElement.eingeschlossen = false;
         } 
    if(schwarmElement.getAbstandER()>0 && schwarmElement.getAbstandER() <50) {
          //gefressene Elemente in neuer ArrayList sammeln
          schwarmElementZuLoeschen.add(schwarmElement);
          //Löschen aus einer Schleife heraus führt zu inkonsistenten ArrayLists 
    } 
    if(schwarm.size()> 250){//Verhindert Überbevölkerung
        schwarmElementZuLoeschen.add(schwarm.get(250)); 
    }    
    //Abstand zum Futter berechenen  
    dFutter = sqrt(sq(schwarmElement.getOrt().x-futter.getOrt().x)+sq(schwarmElement.getOrt().y-futter.getOrt().y)); 
    if(dFutter < 14){ 
      schwarmElementNeuGeboren.add(new SchwarmElement(futter.getOrt()));
    }
    schwarmElement.display(voegelAnzeigen); //Schwarm-Element entweder Fische oder Vögel
  }
//////////////////////////////////////////////////////////////////////////////////////////
   for(SchwarmElement schwarmElement: schwarmElementZuLoeschen){//muss außerhalb der obigen for-Schleife liegen
      schwarm.remove(schwarmElement);    //gefressene Elemente löschen   
   }
   schwarmElementZuLoeschen.clear();//Liste leeren
////////////////////////////////////////////////////////////////////////////////////
  for(SchwarmElement schwarmElement: schwarmElementNeuGeboren){
       schwarm.add(new SchwarmElement(new PVector(0.75*width,0.75*height)));    //neugeborene Elemente hinzufügen
   }
   schwarmElementNeuGeboren.clear();//Liste leeren
   if(schwarm.size()!= aktuelleSchwarmGroesse){ 
      aktuelleSchwarmGroesse = schwarm.size();
   }
   if(schwarm.size()< 40){//Verhindert das endgültige Aussterben ;-)
      for (int i=0; i<50; i++){
        schwarm.add(new SchwarmElement(new PVector(0.75*width,0.75*height)));
      }
   }
   
  
////////////////////////////////////////////////////////////////////////////////////
  for (Raeuber einRaeuber: raeuber) {//Über alle Räuber ausführen
    
    if (schwarmVerhalten) { 
      einRaeuber.schwarmRegelnAnwenden(schwarm);
      for (Raeuber andererRaeuber: raeuber){ //Räuber sind Einzelgänger ...
        if (andererRaeuber.getOrt() != einRaeuber.getOrt()){
           einRaeuber.konkurrentenAbstossungsKraft(raeuber);
        }
      }
    }
    for (Hindernis hindernis: hindernisse) { //Hindernis umgehen     
        einRaeuber.hindernisAbstKraft(hindernis.ort, hindernis.radius);
    }    
   if (eingeschlossen){
      einRaeuber.eingeschlossen = true;    
    } 
    //Anpassung Anzahl Räuber an Anzahl Beute
    if(schwarm.size()>200 && raeuber.size()==2) raeuberGeboren = true;
    if(schwarm.size()<100 && raeuber.size()==2) raeuberGestorben = true;
    if(schwarm.size()<200 && raeuber.size()==3) raeuberGestorben = true;
    if(schwarm.size()>100 && raeuber.size()==1) raeuberGeboren = true;
    einRaeuber.display(voegelAnzeigen);
  }
  
   if(raeuberGeboren ) {
     raeuber.add(new Raeuber(new PVector(0.25*width,0.25*height)));
     raeuberGeboren = false;
   }  
  
   if(raeuberGestorben){
     int rS = raeuber.size();
     raeuber.remove(raeuber.get(rS-1));
     raeuberGestorben = false;
   }
}
/////////////////////////////////////////////////////////////////////////////
void keyPressed(){
  if(key == 's')   schwarmVerhalten = !schwarmVerhalten;
  if(key == 'e')   eingeschlossen = !eingeschlossen;
  if(key == 'v')   voegelAnzeigen = !voegelAnzeigen;
  if(key == 'j')   jagenR = !jagenR;
}
///////////////////////////////////////////////////////////////
void mousePressed(){
  //Am Maus-Ort...
   if (mouseButton == LEFT) { 
    for(int i = 0; i<3;i++) //10 Elemente werden um den Maus-Klick-Ort verteilt
      schwarm.add(new SchwarmElement(new PVector(mouseX+random(-20,20), mouseY+random(-20,20))));
  }
  if (mouseButton == RIGHT) {//hellgraues Hindernis mit Radius zwischen 20 und 40 bei Rechtsklick hinzufügen
    hindernisse.add(new Hindernis(new PVector(mouseX, mouseY),random(15,25),color(0,0,90)));
  }  
}

class SchwarmElement {

  PVector ort;
  PVector geschwindigkeit;
  PVector beschleunigung;
  PVector beschlDelta ;
  PVector senkrechtKraft;
  PVector gegenKraft;
  float masse; //Masse des Schwarm-Elements
  float maxGeschwindigkeit; 
  PVector hindernis;
  PVector raeuberOrt;
  float radius;
  float sichtWeite;
  float winkelAbweichung;
  color farbe;
  boolean eingeschlossen;
  int vorzeichen;
  float temp;
  float dER; //Abstand schwarmElement-raeuber
 
  SchwarmElement(PVector ort) {

    this.ort = ort; //Schwarm-Element Start-Ort vorgeben. 
    //Geschwindigkeit und Beschleunigung zu Beginn Null
    geschwindigkeit = new PVector();
    beschleunigung = new PVector();
    beschlDelta = new PVector();
    senkrechtKraft = new PVector();
    gegenKraft = new PVector();
    masse = int(random(5, 10));//Masse bestimmen
    farbe = color(random(30,90),100,100);
    sichtWeite = 100;
    maxGeschwindigkeit = 6;
    dER =0;
  }

//////////////////////////////////////////////////////////////////////////////////

  void schwarmRegelnAnwenden(ArrayList<SchwarmElement> schwarm) {
    //Drei Schwarm-Regeln einhalten:
        abstossungsKraft(schwarm);//kleiner Wirkradius, kleine Kraft...
        anziehungsKraft(schwarm); //großer Wirkradius, große Kraft
        abstossungsKraft(schwarm);//...dafür nochmal anwenden
        richtungsKraft(schwarm);
        abstossungsKraft(schwarm);//...und nochmal...
  }
/////////////////////////////////////////////////////////////////////////////////////
  void update() {
    //Nächste Position des Schwarm-Elements berechnen
    geschwindigkeit.add(beschleunigung);
    ort.add(geschwindigkeit);
    beschleunigung.mult(0); //Beschleunigung jedesmal auf Null setzen
    geschwindigkeit.limit(maxGeschwindigkeit); 
    //Auf einer Seite raus - auf der gegenüberliegenden Seite rein, wenn nicht eingesperrt
    if(!eingeschlossen){
      if (ort.x<=0) {
        ort.x = width;
      }
      if (ort.x>width) {
        ort.x = 0;
      }
      if (ort.y<=0) {
        ort.y = height;
      }
      if (ort.y>height) {
        ort.y = 0;
      }
    }else{
      if( ort.x < abstandRand){
         PVector kraft = new PVector(2*(abstandRand-ort.x),0);
         kraftAnwenden(kraft);
      }
      if( ort.x > width-abstandRand){
         PVector kraft = new PVector(-2*(ort.x-width+abstandRand),0);
         kraftAnwenden(kraft);
      }
      if( ort.y < abstandRand){
         PVector kraft = new PVector(0,2*(abstandRand-ort.y));
         kraftAnwenden(kraft);
      }
      if( ort.y > height-abstandRand){
         PVector kraft = new PVector(0,-2*(ort.y-height+abstandRand));
         kraftAnwenden(kraft);
      }     
    }
    
  }
  
///////////////////////////////////////////////////////////////////////////////
  void kraftAnwenden(PVector kraft) {
    //Kraft = Masse * Beschleunigung
      beschlDelta.x = kraft.x/masse;
      beschlDelta.y = kraft.y/masse;   
      beschleunigung.add(beschlDelta);
  }
/////////////////////////////////////////////////////////////////////////////////////////////
  void display( boolean voegelAnzeigen) {//Fische oder Vögel anzeigen
    update();
    //fill(0, 0);
    stroke(0); 
    strokeWeight(0.1);
    if (voegelAnzeigen) {//Vögel   
        pushMatrix();
        translate(ort.x, ort.y);
        rotate(geschwindigkeit.heading());//heading...Winkel im Bogenmaß
        fill(this.farbe);
        beginShape();//Vogel-Shape
          curveVertex(10,0);
          curveVertex(10,0);
          curveVertex(6,6);      
          curveVertex(0,10);         
          curveVertex(4,0);       
          curveVertex(0,-10);          
          curveVertex(6,-6);          
          curveVertex(10, 0);
          curveVertex(10,0);
         endShape();
         popMatrix();
    }else { //Fische        
        pushMatrix();
        translate(ort.x+3*geschwindigkeit.x, ort.y+3*geschwindigkeit.y);
        rotate(geschwindigkeit.heading());//heading...Winkel im Bogenmaß
        fill(this.farbe);
        beginShape();//Fisch-Shape
          curveVertex(10,0);
          curveVertex(10,0);
          curveVertex(7,3);
          curveVertex(0,4);
          curveVertex(-6,1);
          curveVertex(-10,3);
          curveVertex(-10,-3);
          curveVertex(-6,-1);
          curveVertex(0,-4);
          curveVertex(7,-3);
          curveVertex(10, 0);
          curveVertex(10,0);
        endShape();
        popMatrix();
    }
  }

//////////////////////////////////////////////////////////////////////////////////////////////////
 void abstossungsKraft(ArrayList<SchwarmElement> schwarm) { //Anwendbar nur auf SchwarmElemente, die keine Räuber sind
    //Kraft - abstoßend vom Mittelwert des nahen Schwarmortes der zu nahen Elemente
    float anzahlWirksame = 0; //Wieviele Elemente sind zu nah
    float abstandMin=0;
    float d=0;
    PVector ortSum = new PVector(); //Alle Koordinaten der zu nahen Elemente werden aufsummiert

    for (SchwarmElement einElement: schwarm) {
      abstandMin =masse+10; //Mindestdistanz (leicht abhängig von der Masse wegen Trägheit) 
      //Elemente, die einen kleineren Abstand haben, tragen zur Abstoßungskraft bei
      PVector abstand = PVector.sub(einElement.getOrt(), ort); //Differenzvektor
      d = abstand.mag();//Abstand zu den anderen Elementen      
      if (d != 0 && d<abstandMin) { //Wenn Abstand zu klein oder Abstand zu sich selbst
        PVector einElementOrt = einElement.getOrt();
        ortSum.add(einElementOrt); //Summenbildung für die Mittelswertsberechnung
        anzahlWirksame ++;
      }
    }
    if (anzahlWirksame>0) { 
      ortSum.div(anzahlWirksame); //Mittelwerts-Vektor
      PVector abstVektMittel = PVector.sub(ort, ortSum); //Abstandsvektor zum Mittelwerts-Ort
      d=abstVektMittel.mag();
      //abstVektMittel.limit(maxKraft); //Begrenzung des Betrags von abstVektMittel auf (limit) maxKraft
      abstVektMittel.normalize();
      abstVektMittel.x= 5* abstVektMittel.x/d;
      abstVektMittel.y= 5* abstVektMittel.y/d;
      kraftAnwenden(abstVektMittel);//Je kleiner der Abstand, desto größer die Kraft
    }
  }
////////////////////////////////////////////////////////////////////////////////////////////////////
void anziehungsKraft(ArrayList<SchwarmElement> schwarm) {
    float anzahlWirksame = 0; //wieviele Elemente ziehen an
    float d ;
    float abstandMax;
    PVector ortSum = new PVector(); //Alle Koordinaten der berücksichtigten Elemente werden aufsummiert    
    abstandMax= masse +sichtWeite; //Maximaldistanz bis zu der die anderen berücksichtigt werden   
    for (SchwarmElement einElement: schwarm) {//Elemente, die einen kleineren Abstand haben, tragen zur Anziehungskraft bei      
      PVector abstand = PVector.sub(einElement.getOrt(), ort);//Differenzvektor
      d = abstand.mag();//Abstand zu den anderen Elementen
      if (d != 0 && d<abstandMax) {
        PVector einElementOrt = einElement.getOrt();
        ortSum.add(einElementOrt);//Mittelwerts-Vektor
        anzahlWirksame ++;
      }
    }
    if (anzahlWirksame>0) {
      ortSum.div(anzahlWirksame);
      PVector abstVektMittel = PVector.sub(ortSum, ort);      
      d=abstVektMittel.mag(); 
      abstVektMittel.normalize(); 
      abstVektMittel.x= 10* abstVektMittel.x/d;
      abstVektMittel.y= 10* abstVektMittel.y/d;
      kraftAnwenden(abstVektMittel);
    }
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////
  void richtungsKraft(ArrayList<SchwarmElement> schwarm) {
    float anzahlWirksame = 0; //wieviele Elemente sind wirksam (Radius abhängig)
    PVector geschwindigkeitSum = new PVector(); //Alle Geschwindigkeits-Vektoren der berücksichtigten Elemente werden aufsummiert
    float abstandMax;
    float d;
    for (SchwarmElement einElement: schwarm) {
      abstandMax = masse + sichtWeite;//Auch weiter entfernte Elemente (bis Sichtweite) werden zur Korrektur des Geschwindigkeits-
      //vektors einbezogen
      PVector abstand = PVector.sub(einElement.getOrt(), ort);
      d = abstand.mag();//Abstand zu den anderen Elementen

      if (d != 0 && d<abstandMax) {
        PVector einElementGeschw = einElement.getGeschw();
        geschwindigkeitSum.add(einElementGeschw);
        anzahlWirksame ++;
      }
    }
    if (anzahlWirksame>0) {
      geschwindigkeitSum.div(anzahlWirksame);//Mittelwerts-Vektor der Geschwindigkeit
      PVector durchschnittsGeschwindigkeit = geschwindigkeitSum;
      durchschnittsGeschwindigkeit.x = 2*durchschnittsGeschwindigkeit.x;
      durchschnittsGeschwindigkeit.y = 2*durchschnittsGeschwindigkeit.y;
      kraftAnwenden(durchschnittsGeschwindigkeit);
    }
  }
////////////////////////////////////////////////////////////////////////////////////////////
  void hindernisAbstKraft(PVector hindernis, float radius) {//...um Elemente vom Hindernis fern zu halten
    this.hindernis = hindernis;
    this.radius = radius;
    PVector naechstePosition = PVector.add(ort, geschwindigkeit); 
    PVector abstand = PVector.sub(hindernis, naechstePosition);
    float d = abstand.mag();
    PVector ortHindernisVektor = PVector.sub(hindernis, ort);
    ortHindernisVektor.normalize();
    temp = ortHindernisVektor.heading()-geschwindigkeit.heading();
    if(temp > 0) vorzeichen =1;
    if(temp < 0) vorzeichen =-1;
    winkelAbweichung = abs(temp);
    
    //Frühzeitig weg von Kollisionskurs  durch Kraft senkrecht zur Geschw.(innerhalb eines Bereiches)
    if(winkelAbweichung <0.8 && d<=radius+sichtWeite && d>radius+50 ){
       ortHindernisVektor.mult(vorzeichen*(radius+sichtWeite-d));
       senkrechtKraft.x =  ortHindernisVektor.y;
       senkrechtKraft.y = -ortHindernisVektor.x;
       kraftAnwenden(senkrechtKraft); 
    }  
    //Element innehalb radius+20 und radius+50
    if(d<=radius+50 & d>=radius+20){
      kraftAnwenden(new PVector(-1*ortHindernisVektor.x,-1*ortHindernisVektor.y)); 
    }
     //Element unterhalb radius+20 
    if(d<radius+20 ){
      kraftAnwenden(new PVector(-40*ortHindernisVektor.x,-40*ortHindernisVektor.y)); 
    }
  }  
////////////////////////////////////////////////////////////////////////////////  
 void fluchtKraft( PVector raeuberOrt) {//...um von Räubern zu fliehen
    this.raeuberOrt = raeuberOrt;
    PVector naechstePosition = PVector.add(ort, geschwindigkeit); 
    PVector abstand = PVector.sub(raeuberOrt, naechstePosition);//vorausdenken ;-)
    dER = abstand.mag(); 
    //if (dER <50) println("in der Klasse "+dER);
    PVector ortRaeuberVektor = PVector.sub(raeuberOrt, ort);
    ortRaeuberVektor.normalize();  
    if(dER<=sichtWeite+20 & dER>=10){  
       ortRaeuberVektor.x = -3000*ortRaeuberVektor.x/dER;
       ortRaeuberVektor.y = -3000*ortRaeuberVektor.y/dER;
       gegenKraft = ortRaeuberVektor;
       kraftAnwenden(gegenKraft);     
    }   
 }
//////////////////////////////////////////////////////////////////////////////////
  PVector getOrt() {
    return ort;
  }
/////////////////////////////////////////////////////////////////////////////////////
  PVector getGeschw() {
    return geschwindigkeit;
  }
//////////////////////////////////////////////////////////////////////////
 float getAbstandER(){
    return dER;
 }
}

/////////////////////////////////////////////////////////////////////////////////
//Raeuber haben gemeinsame und nicht gemeinsame Methoden mit SchwarmElement
//////////////////////////////////////////////////////////////////////////
class Raeuber extends SchwarmElement { 

  float sichtWeite; //Sichtweite des Räubers
  float maxGeschwindigkeit;

  boolean eingeschlossen;
  color farbe;
  
  Raeuber(PVector ort) {
    super(ort);
    sichtWeite = 200;
    masse = int(random(8, 15)); 
    eingeschlossen = false;
    farbe = color(random(0,20),100,100);
    maxGeschwindigkeit =12;
  }

  void display(boolean voegelAnzeigen) {//Fische oder Vögel anzeigen) 
    update();
    stroke(0); 
    strokeWeight(0.1);
    if (voegelAnzeigen) {//Vögel   
        pushMatrix();
        translate(ort.x, ort.y);
        rotate(geschwindigkeit.heading());//heading...Winkel im Bogenmaß
        fill(this.farbe);
        beginShape();//Vogel-Shape
          curveVertex(20,0);
          curveVertex(20,0);
          curveVertex(12,12);      
          curveVertex(0,20);         
          curveVertex(8,0);       
          curveVertex(0,-20);          
          curveVertex(12,-12);          
          curveVertex(20, 0);
          curveVertex(20,0);
         endShape();
         popMatrix();
    }else { //Fische        
        pushMatrix();
        translate(ort.x+3*geschwindigkeit.x, ort.y+3*geschwindigkeit.y);
        rotate(geschwindigkeit.heading());//heading...Winkel im Bogenmaß
        fill(this.farbe);
        beginShape();//Fisch-Shape
          curveVertex(20,0);
          curveVertex(20,0);
          curveVertex(14,6);
          curveVertex(0,8);
          curveVertex(-12,2);
          curveVertex(-20,6);
          curveVertex(-20,-6);
          curveVertex(-12,-2);
          curveVertex(0,-8);
          curveVertex(14,-6);
          curveVertex(20, 0);
          curveVertex(20,0);
        endShape();
        popMatrix();
    }
  }  
  //////////////////////////////////////////////////////////////////////////////////

  void schwarmRegelnAnwenden(ArrayList<SchwarmElement> schwarm) {//Überschriebene Methode
      //Drei Schwarm-Regeln einhalten.  
        anziehungsKraft(schwarm); //Methode überschrieben
        richtungsKraft(schwarm);//Methode nicht überschrieben
        konkurrentenAbstossungsKraft(raeuber);//Reine Räuber-Methode    
  }
///////////////////////////////////////////////////////////////////////////////////////////
  void update() { 
    //Wie bei SchwarmElement, - nur schneller und schwächere Abstoßung vom Rand (Jagdvorteil!)
    geschwindigkeit.add(beschleunigung);
    ort.add(geschwindigkeit);
    beschleunigung.mult(0); //Jedes Mal Beschleunigung auf Null setzen.
    geschwindigkeit.limit(maxGeschwindigkeit); 
    if(!eingeschlossen){
      if (ort.x<=0) {
        ort.x = width;
      }
      if (ort.x>width) {
        ort.x = 0;
      }
      if (ort.y<=0) {
        ort.y = height;
      }
      if (ort.y>height) {
        ort.y = 0;
      }
   }else{
     if( ort.x < abstandRand){
         PVector kraft = new PVector((abstandRand-ort.x),0);
         kraftAnwenden(kraft);
      }
      if( ort.x > width-abstandRand){
         PVector kraft = new PVector(-1*(ort.x-width+abstandRand),0);
         kraftAnwenden(kraft);
      }
      if( ort.y < abstandRand){
         PVector kraft = new PVector(0,(abstandRand-ort.y));
         kraftAnwenden(kraft);
      }
      if( ort.y > height-abstandRand){
         PVector kraft = new PVector(0,-1*(ort.y-height+abstandRand));
         kraftAnwenden(kraft);
      }
   }
  }
///////////////////////////////////////////////////////////////////////////////////////////////////////////
  void anziehungsKraft(ArrayList<SchwarmElement> schwarm) { //Überschriebene Methode
    float d;
    float anzahl = 0;
    PVector ortSum = new PVector();

    for (SchwarmElement andere: schwarm) {

      float abstandMax = masse + sichtWeite;//Wirkungsbereich der Anziehungkraft...
      PVector abstand = PVector.sub(andere.getOrt(), ort);// Viel größer als bei Abstoßungskraft
      d = abstand.mag();
      if (d != 0 && d<abstandMax) {
        PVector andereLoc = andere.getOrt();
        ortSum.add(andereLoc);
        anzahl ++;
      }
    }
    if (anzahl>0) {
      ortSum.div(anzahl);
      PVector abstandVektorMittel = PVector.sub(ortSum, ort);
      d = abstandVektorMittel.mag();
      abstandVektorMittel.normalize();
      if(d!=0)
      abstandVektorMittel.x = 250*abstandVektorMittel.x/d;
      abstandVektorMittel.y = 250*abstandVektorMittel.y/d;
      kraftAnwenden(abstandVektorMittel); 
    }
  }
/////////////////////////////////////////////////////////////////////
  
   float getSichtweite() {
    return sichtWeite;
  }
  //////////////////////////////////////////////////////////////////////////////////////////////////
  void konkurrentenAbstossungsKraft(ArrayList<Raeuber> raeuber) { 
    //Kraft - abstoßend vom Mittelwert des Schwarmortes
    float abstandMin =0;
    float d =0; //Abstand
    float anzahlWirksame = 0; //Wieviele Elemente sind zu nah
    PVector ortSum = new PVector(); //Alle Koordinaten der zu nahen Elemente werden aufsummiert

    for (Raeuber einRaeuber: raeuber) {
       abstandMin =masse+50; //Mindestdistanz (leicht abhängig von der Masse wegen Trägheit) 
       //Elemente, die einen kleineren Abstand haben, tragen zur Abstoßungskraft bei
       PVector abstand = PVector.sub(einRaeuber.getOrt(), ort); //Differenzvektor
       d = abstand.mag();//Abstand zu den anderen Elementen 
       if (d != 0 && d<abstandMin) { //Wenn Abstand zu klein oder Abstand zu sich selbst
        PVector einRaeuberOrt = einRaeuber.getOrt();
        ortSum.add(einRaeuberOrt); //Summenbildung für die Mittelswertsberechnung
        anzahlWirksame ++;      
       }
        if (anzahlWirksame>0) { 
            ortSum.div(anzahlWirksame); //Mittelwerts-Vektor
            PVector abstandVektorMittel = PVector.sub(ort, ortSum); //Abstandsvektor zum Mittelwerts-Ort
            d= abstandVektorMittel.mag();
            abstandVektorMittel.normalize();
            //Je näher zusammen, desto größer die Abstoßungskraft:
            abstandVektorMittel.mult(100/d);
            if(d!=0) kraftAnwenden(abstandVektorMittel);
          
        }
    }  
  }
}

class Hindernis {

  PVector ort;
  float radius;
  color farbe;

  Hindernis(PVector ort, float radius, color farbe ) {
   this.ort = ort;
   this.radius = radius;//println(radius);
   this.farbe = farbe;
   ellipseMode(RADIUS); 
  }
  
  void display(){
    noStroke();
    fill(farbe);
    ellipse(ort.x,ort.y,radius,radius);
  
  }
   
}

class FutterStelle  extends Hindernis {
  
     FutterStelle(PVector ort, float radius, color farbe ){
         super(ort,radius,farbe);      
     }    
     void display(){
        stroke(0,0,0);
        strokeWeight(3);
        fill(farbe);
        rectMode(CENTER);
        rect(ort.x,ort.y,radius,radius);
        point(ort.x,ort.y);
        noFill();
        rect(1.5*ort.x, 1.5*ort.y, radius,radius);//hier werden die Schwarmelemente geboren
        rect(0.5*ort.x, 0.5*ort.y, radius,radius);//... und hier die Räuber
       
     }
     
     PVector getOrt(){
       return ort;
     }
  
}